/****************************************************************************
 *   Copyright (C) 2004 by Jurij Ivastsuk-Kienbaum                          *
 *   jurij@device-image.de                                                  *
 *                                                                          *
 *   This program is free software; you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by   *
 *   the Free Software Foundation; either version 2 of the License,         *
 *   or (at your option) any later version.                                 *
 *   This program is distributed in the hope that it will be useful,        *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty            *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                *
 *   See the GNU General Public License for more details.                   *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to the Free Software Foundation,*
 *   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA            *
 ***************************************************************************/


#define _LARGEFILE_SOURCE
#define _LARGEFILE64_SOURCE
#define _FILE_OFFSET_BITS 64


#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <getopt.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "zlib.h"
#include <dirent.h>
#include <vector>

#include "safe_read.h"
#include "safe_write.h"

#include "common_tools.h"

using namespace std;

#ifndef MAX_PATH_LEN
#  define MAX_PATH_LEN   1024 /* max pathname length */
#endif


unsigned int find_last_chunk_nr(vector<string> &cont);

string check_get_name(string strname);

string find_chunk_name(vector<string> &cont, string name_patt);

int search_file_parts(string iname, unsigned int chunk_count);

void close_in_out_files(int ifd, int ofd);


int do_stat(const char *name, struct stat *sbuf);


int do_stat(int fd, struct stat *sbuf);

uInt seek_on_err(int ifd, size_t count);


int treat_file(string iname);

int treat_stdin();

int do_unzsplit(int ifd, int ofd, string path_ifn, string path_ofn);

int do_unzsplit(int ifd, int ofd, string path_ifn);

void usage();

void help();

string av_speed(unsigned long time_sec, unsigned long long total_bytes_read);
